#ifndef SCRIPTCONTROL
#define SCRIPTCONTROL

#include "..\C-Engine\CEngine.hpp"
#include "GUI.hpp"

//Kirby script

enum Contenu
{ Vide , Air , Plein};

class SSoufle: public Script
{
    public:
    void Update();

    bool direction;
    int time;

    Script_GUI * Interface;

};

class SAspi: public Script
{
    public:
    void Update();
};

class SStar: public Script
{
    public:
    void Update();

    bool direction;
    Script_GUI * Interface;
};

class Control: public Script
{
    public:

    void Start();
    void Update();
    void Initialisation(Animation E, Animation S , Object * A , Script_GUI * G);
    void Teleport( int x , int y , int level );
    void GenerateMonster();

    Animation  AOurs;
    Animation  ABaby;
    Animation  AGhost;
    Animation  AOupa;
    Animation * APiaf;
    Animation * AChamp;


    private:

        bool isground; // Si Touche le sol True
        bool isdo; // Si ralise une action True
        bool isaspi;
        int isfull;
        int ishurt;
        int isnhit;

        bool direction; // Direction du personnage True = Gauche

        int oldx;
        int oldy;

        Animation  RenderSouffle;
        Animation RenderEtoile;

        Object * OAspi;

        Script_GUI * Interface;

        int couldown;

        bool boss;

};

#endif // SCRIPTCONTROL
