#ifndef IAMONSTRE
#define IAMONSTRE

#include "..\C-Engine\CEngine.hpp"

// Mob script

class Mob: public Script
{
    public :

    Mob();

    void SetDirection( bool d);
    void SetCouldown( int c);

    bool direction;
    int couldown;
};

class Mob_InLine: public Mob
{
    public:

    void Update();
};

class Mob_InLine_Jump: public Mob_InLine
{
    public:

    void UpdateEverySecond();
};

class Mob_InLine_Fly: public Mob_InLine
{
    public:

    void Update();
};

class Mob_Piaf: public Mob
{
    public:

    void Update();
    void UpdateEverySecond();
};

class Mob_Champ: public Mob
{
    public:

    void Update();
};

#endif
